unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type
  { TMyThread }
  TMyThread = class(TThread)
  private
    fStatusText : string;
    procedure ShowStatus;
  protected
    procedure Execute; override;
  public
    Constructor Create(CreateSuspended : boolean);
  end;

  { TForm1 }
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure OnThreadDone(ASender : TObject);
  private

  public
    MyThread : TMyThread;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  if Button1.Caption = 'Start' then
  begin
    MyThread := TMyThread.Create(True); // This way it doesn't start automatically
    MyThread.FreeOnTerminate := True;
    MyThread.OnTerminate := @OnThreadDone;
    MyThread.Start;
    Button1.Caption := 'Stop';
  end
  else if Button1.Caption = 'Stop' then
  begin
    MyThread.Terminate;
    Button1.Caption := 'Start';
  end;
end;

procedure TForm1.OnThreadDone(ASender : TObject);
begin
  Form1.Caption := 'TMyThread Stopped';
end;

constructor TMyThread.Create(CreateSuspended : boolean);
begin
  inherited Create(CreateSuspended);
  //FreeOnTerminate := True;  --> see Button1Click event
end;

procedure TMyThread.ShowStatus;
// this method is executed by the mainthread and can therefore access all GUI elements.
begin
  Form1.Caption := fStatusText;
  Application.ProcessMessages;
  Sleep(400);
end;

procedure TMyThread.Execute;
var
  newStatus : string;
begin
  fStatusText := 'TMyThread Starting...';
  Synchronize(@Showstatus);
  fStatusText := 'TMyThread Timer: ' + FormatDateTime('YYYY.MM.DD HH:NN:SS', Now);
  Synchronize(@Showstatus);
  while (not Terminated) do
  begin
    newStatus := 'TMyThread Timer: ' + FormatDateTime('YYYY.MM.DD HH:NN:SS', Now);
    if NewStatus <> fStatusText then
    begin
      fStatusText := newStatus;
      Synchronize(@Showstatus);
    end;
    //********************************************************************
    // Hier ist das Problem: Ich möchte blockierende Codeabschnitte
    // im Thread sauber (ohne Memory Leak) unterbrechen.
    while true do ;
    //********************************************************************
    sleep(300) // save computing capacity power / energy
  end;
end;

end.

